--巅峰战斗录像列表
Lua_PeakDuelFightDetailsWindow = class("Lua_PeakDuelFightDetailsWindow", Lua_Window);
function Lua_PeakDuelFightDetailsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_PeakDuelFightDetailsWindow";
	self.skinName = "PeakDuelFightDetailsWindow_skin";
    self.showBlackMask = true;
    self.isClickClose = true;
end

function Lua_PeakDuelFightDetailsWindow:buildShowItem()
	self:superCall("buildShowItem")

    self:addLuaEvent("PEAK_DUEL_DETAILS", self, self.onCheckDetails);
    self:addLuaEvent("PEAK_DUEL_DETAILS_HURT", self, self.onCheckDetailsHurt);

	self.dragList = Lua_DragList.new(self.content, 705, 800, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_PeakDuelFightDetailsCell, 705, 400, 1);
    self.dragList:setLocation(0, -30);
end

function Lua_PeakDuelFightDetailsWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_PeakDuelFightDetailsWindow:showWin(param)
	self:superCall("showWin", param);

	local left_name = "["..param.data.attack_role.show_role.server_prev.."]"..param.data.attack_role.show_role.name;
	local right_name = "["..param.data.defence_role.show_role.server_prev.."]"..param.data.defence_role.show_role.name;
	self.left_name.text = left_name;
	self.right_name.text = right_name;
	self.show_num.text = param.data.attack_win_times.." : "..param.data.defence_win_times;


	local arr = Array();
	local data = param.data.fight_data;
	for i = 1, 2 do
		if data == nil or #data >= i then
			arr:add({ fight_tick = param.data.fight_tick, left_name = left_name, right_name = right_name, data = data[i] });
		else
			arr:add({ fight_tick = param.data.fight_tick, left_name = left_name, right_name = right_name, data = nil });
		end
	end
	self.dragList:setArrayData(arr);
end

function Lua_PeakDuelFightDetailsWindow:onCheckDetails(fight_times)
	if self.showData == nil then
		return;
	end

	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(self.showData.data.record_id, 0, "", fight_times, self.showData.recordIdx);
end

function Lua_PeakDuelFightDetailsWindow:onCheckDetailsHurt(fight_times)
	if self.showData == nil then
		return;
	end

	local list = self.showData.data.fight_data;
	if list ~= nil then
		local hurtInfo = {};
		hurtInfo.defender = self.showData.data.defence_role.show_role;
		hurtInfo.attacker = self.showData.data.attack_role.show_role;
		hurtInfo.win_type = self.showData.data.win_id;
		hurtInfo.hurt_collect_list = {};

		for i = 1, #list do
			hurtInfo.hurt_collect_list[i] = { rotation = list[i].fight_times, defender_hurt_collect = list[i].defence_fight_hurt, attacker_hurt_collect = list[i].attack_fight_hurt };
		end

		Lua_WindowUtil.openWin("Lua_FightOverallHurtWindow", Lua_WinParam.ACTION_OPEN, { selectIdx = fight_times, hurtInfo = hurtInfo });
	end
end













-- 录像列表
Lua_PeakDuelFightDetailsCell = class("Lua_PeakDuelFightDetailsCell", Lua_ListCell);
function Lua_PeakDuelFightDetailsCell:ctor(p)
    self:superCall("ctor", p,"PeakDuelFightDetailsCell_skin");
end

function Lua_PeakDuelFightDetailsCell:buildShowItem()
    self:superCall("buildShowItem");

	self.leftLineupPanel = Lua_HeroGridViewPanel.new(self.showObject);
	self.leftLineupPanel:setLocation(-220, 0, 0);

	self.rightLineupPanel = Lua_HeroGridViewPanel.new(self.rightObject);
	self.rightLineupPanel:setLocation(220, 0, 0);

    self.noneText:setEnable(false);
    self.play_btn:addClickFuntion(self, self.onPlayBtnClick); --回放
    self.checkHurt:addClickFuntion(self, self.onCheckHurtClick); --数据
end

function Lua_PeakDuelFightDetailsCell:dispose()
	if self.leftLineupPanel ~= nil then
		self.leftLineupPanel:dispose();
		self.leftLineupPanel = nil;
	end
	if self.rightLineupPanel ~= nil then
		self.rightLineupPanel:dispose();
		self.rightLineupPanel = nil;
	end
    self.data = nil;
    self:superCall("dispose");
end

function Lua_PeakDuelFightDetailsCell:setData(data)
    self.data = data;

    if data.data == nil then
    	self.showObject:SetActive(false);
    	self.noneText:setEnable(true);
    	self.noneText:setLocation(0, 0, 0);
    else
    	self.showObject:SetActive(true);
    	self.noneText:setEnable(false);

	    if data.data.win_id == 1 then
	        self.left_result:setAltas("common_altas_3", "ui_zd_icon_011");
	        self.right_result:setAltas("common_altas_3", "ui_zd_icon_012");
	    else
	        self.left_result:setAltas("common_altas_3", "ui_zd_icon_012");
	        self.right_result:setAltas("common_altas_3", "ui_zd_icon_011");
	    end

		local maxRound = Lua_FightTemplateConfigData.getConfigData(Lua_FightDefine.TEMPLATE_ID_PEAKDUEL).maxRound;
		self.show_round.text = data.data.fight_rounds.."/"..maxRound;
		self.match_time.text = os.date("%Y-%m-%d %H:%M", tonumber(data.fight_tick));

    	self.left_name.text = data.left_name;
    	self.left_team.text = LanUtil.formateStr("队伍{1}", tostring(data.data.attack_lineup.index));
    	self.left_force.text = LanUtil.formateStr("战力：{1}",data.data.attack_lineup.force);

		self.left_bar:setMaxValue(100);
		local value = Mathf.Floor(data.data.attack_blood * 100);
		self.left_bar:setValue(value);
		self.left_bar:setText(value.."%");

		self.leftLineupPanel:setDataByProto(data.data.attack_lineup.hero_list);

		self.right_name.text = data.right_name;
		if data.data.defence_lineup == nil or data.data.defence_lineup.index <= 0 then
			self.checkHurt:setEnable(false);
			self.rightObject:SetActive(false);
			self.noneText:setEnable(true);
	    	self.noneText:setLocation(220, 0, 0);
		else
			self.checkHurt:setEnable(true);
			self.rightObject:SetActive(true);
			self.noneText:setEnable(false);

			self.right_team.text = LanUtil.formateStr("队伍{1}", tostring(data.data.defence_lineup.index));
			self.right_force.text = LanUtil.formateStr("战力：{1}",data.data.defence_lineup.force);

			self.right_bar:setMaxValue(100);
			value = Mathf.Floor(data.data.defence_blood * 100);
			self.right_bar:setValue(value);
			self.right_bar:setText(value.."%");

			self.rightLineupPanel:setDataByProto(data.data.defence_lineup.hero_list);
		end
    end
end

function Lua_PeakDuelFightDetailsCell:onPlayBtnClick(go)
	if self.data == nil then
		return;
	end	
	Lua_MsgUtil.callFunc("PEAK_DUEL_DETAILS", self.data.data.fight_times);
end

function Lua_PeakDuelFightDetailsCell:onCheckHurtClick(go)
	if self.data == nil then
		return;
	end	
	Lua_MsgUtil.callFunc("PEAK_DUEL_DETAILS_HURT", self.data.data.fight_times);
end