--巅峰竞猜记录
Lua_PeakDuelGuessRecordWindow = class("Lua_PeakDuelGuessRecordWindow", Lua_Window);
function Lua_PeakDuelGuessRecordWindow:ctor()
	self:superCall("ctor");

    self.w = 703;
    self.h = 800;
	self.windowName = "Lua_PeakDuelGuessRecordWindow";
    self.showWinBg = true;
    self.winBgAtlas = "common_altas_1";
    self.winBgSprite = "ui_common_window_007";
    self.showBlackMask = true;
    self.isClickClose = true;
end

function Lua_PeakDuelGuessRecordWindow:buildShowItem()
	self:superCall("buildShowItem")

    self:addLuaEvent("PEAK_DUEL_GUESS_RECORD", self, self.showGuessRecordInfo);

	self.dragList = Lua_DragList.new(self.content, 680, 680, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_PeakDuelGuessRecord, 680, 180, 1);
    self.dragList:setLocation(0, -25);

	Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDGuessRecord();
end

function Lua_PeakDuelGuessRecordWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    self:superCall("dispose");
end

function Lua_PeakDuelGuessRecordWindow:showGuessRecordInfo(msg)
    if msg == nil then
        return;
    end

	self.dragList:setArrayData(msg.guess_record_list);
end













-- 竞猜记录
Lua_PeakDuelGuessRecord = class("Lua_PeakDuelGuessRecord", Lua_ListCell);
function Lua_PeakDuelGuessRecord:ctor(p)
    self:superCall("ctor", p,"PeakDuelGuessRecord_skin");
end

function Lua_PeakDuelGuessRecord:buildShowItem()
    self:superCall("buildShowItem");

    self.leftAvatar = Lua_AvatarItem.new(self.avatarObject);
    self.leftAvatar:setLocation(-260, 0, 0);

    self.rightAvatar = Lua_AvatarItem.new(self.avatarObject);
    self.rightAvatar:setLocation(-50, 0, 0);

    self.checkInfo:addClickFuntion(self, self.onCheckInfo);
    self.checkVideo:addClickFuntion(self, self.onCheckVideo);
end

function Lua_PeakDuelGuessRecord:dispose()
    if self.leftAvatar ~= nil then
        self.leftAvatar:dispose();
        self.leftAvatar = nil;
    end
    if self.rightAvatar ~= nil then
        self.rightAvatar:dispose();
        self.rightAvatar = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end

function Lua_PeakDuelGuessRecord:setData(data)
    self.data = data;
    if data == nil then
        return;
    end

    local role = data.attack_role.show_role;
    self.leftAvatar:setRoleDressUp(role.dress_info);
    self.left_name.text = role.name;

    role = data.defence_role.show_role;
    self.rightAvatar:setRoleDressUp(role.dress_info);
    self.right_name.text = role.name;

    if data.win_id == 1 then
        self.resultIcon:setLocation(-260, 0, 0);
    else
        self.resultIcon:setLocation(-50, 0, 0);
    end

    if data.bet_id == 0 then
        self.guessIcon:setEnable(false);
        self.get_count.text = 0;
    else
        self.guessIcon:setEnable(true);
        if data.bet_id == 1 then
            self.guessIcon:setLocation(-260, 60, 0);
        else
            self.guessIcon:setLocation(-50, 60, 0);
        end

        local reward;
        local tvo;
        if data.win_id == data.bet_id then
            reward = DataCenter.peakDuelUtil.guess_reward;
        else
            reward = DataCenter.peakDuelUtil.guess_fail_reward;
        end
        tvo = Lua_ToolVo.createToolVo(reward[1][1], reward[1][2]);
        self.get_icon:setAltas(tvo.iconAtlas, tvo.iconSprite);
        self.get_count.text = tvo.count;
    end

    self.guess_times.text = LanUtil.formateStr("支持人数:{1}", data.attack_role_num..":"..data.defence_role_num);
    self.match_time.text = LanUtil.formateStr("比赛时间:{1}", os.date("%H:%M", data.match_tick));
end

function Lua_PeakDuelGuessRecord:onCheckInfo(go)
    if self.data == nil then
        return;
    end

    local list = self.data.hurt_collect;
    if list ~= nil then
        local hurtInfo = {};
        hurtInfo.defender = self.data.defence_role.show_role;
        hurtInfo.attacker = self.data.attack_role.show_role;
        hurtInfo.win_type = self.data.win_id;
        hurtInfo.hurt_collect_list = {};

        for i = 1, #list do
            hurtInfo.hurt_collect_list[i] = { rotation = list[i].fight_times, defender_hurt_collect = list[i].defence_fight_hurt, attacker_hurt_collect = list[i].attack_fight_hurt };
        end

        Lua_WindowUtil.openWin("Lua_FightOverallHurtWindow", Lua_WinParam.ACTION_OPEN, { selectIdx = 1, hurtInfo = hurtInfo });
    end
end

function Lua_PeakDuelGuessRecord:onCheckVideo(go)
    if self.data == nil then
        return;
    end
    Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(self.data.record_id, 0, "", 0, 3);
end