Lua_PeakDuelMatchPanel = class("Lua_PeakDuelMatchPanel", Lua_DisplayObject);
function Lua_PeakDuelMatchPanel:ctor(p, direction)
	self.direction = direction;
	self:superCall("ctor", p, "PeakDuelMatchPanel_skin");
end

function Lua_PeakDuelMatchPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.bear_icon:setEnable(false);
	self.none_prompt:setEnable(false);
	self.teamObject_2:SetActive(false);

	self.lineupPanel_1 = Lua_HeroGridViewPanel.new(self.teamObject_1);
	self.lineupPanel_1:setLayout(1, self.direction);
end

function Lua_PeakDuelMatchPanel:dispose()
	if self.lineupPanel_1 ~= nil then
		self.lineupPanel_1:dispose();
		self.lineupPanel_1 = nil;
	end
	if self.lineupPanel_2 ~= nil then
		self.lineupPanel_2:dispose();
		self.lineupPanel_2 = nil;
	end
	self:superCall("dispose");
end

function Lua_PeakDuelMatchPanel:setDir(dir)
	-- 1左 2右
	if dir == 1 then
		LuaUtil.setObjPos(self.teamObject_1, -200, 0, 0);
		LuaUtil.setObjPos(self.teamObject_2, 200, 0, 0);
		self.bear_icon:setLocation(200, 0, 0);
		self.none_prompt:setLocation(200, 0, 0);
	else
		LuaUtil.setObjPos(self.teamObject_1, 200, 0, 0);
		LuaUtil.setObjPos(self.teamObject_2, -200, 0, 0);
		self.bear_icon:setLocation(-200, 0, 0);
		self.none_prompt:setLocation(-200, 0, 0);
	end
end

function Lua_PeakDuelMatchPanel:showTeam2(bShow)
	self.bShowTeam2 = bShow;
	self.bear_icon:setEnable(not bShow);
end

function Lua_PeakDuelMatchPanel:setDataByProto(lineup)
	if lineup == nil or #lineup <= 0 then
		return;
	end

	self.lineupPanel_1:setDataByProto(lineup[1].hero_list);
	self.team_force_1.text = lineup[1].force;

	if self.bShowTeam2 == true then
		if #lineup > 1 and lineup[2].index > 0 then
			self.none_prompt:setEnable(false);
			self.teamObject_2:SetActive(true);
			if self.lineupPanel_2 == nil then
				self.lineupPanel_2 = Lua_HeroGridViewPanel.new(self.teamObject_2);
				self.lineupPanel_2:setLayout(1, self.direction);
			end
			self.lineupPanel_1:setDataByProto(lineup[2].hero_list);
			self.team_force_2.text = lineup[2].force;
		else
			self.none_prompt:setEnable(true);
			self.teamObject_2:SetActive(false);
		end
	end
end

function Lua_PeakDuelMatchPanel:setDataByLineupType(lineupType)
	local vo = DataCenter.heroLineupData:getLineupVo(lineupType);
	local force = DataCenter.heroLineupData:calcLineupForce(lineupType, vo:getStandArr(1));
	self.lineupPanel_1:setDataByLineupType(lineupType, 1);
	self.team_force_1.text = force;

	if self.bShowTeam2 == true then
		force = DataCenter.heroLineupData:calcLineupForce(lineupType, vo:getStandArr(2));
		if force > 0 then
			self.none_prompt:setEnable(false);
			self.teamObject_2:SetActive(true);
			if self.lineupPanel_2 == nil then
				self.lineupPanel_2 = Lua_HeroGridViewPanel.new(self.teamObject_2);
				self.lineupPanel_2:setLayout(1, self.direction);
			end
			self.lineupPanel_2:setDataByLineupType(lineupType, 2);
			self.team_force_2.text = force;
		else
			self.none_prompt:setEnable(true);
			self.teamObject_2:SetActive(false);
		end
	end
end