--巅峰对决匹配
checkRequire("Lua_PeakDuelMatchPanel");
Lua_PeakDuelMatchWindow = class("Lua_PeakDuelMatchWindow", Lua_Window);
function Lua_PeakDuelMatchWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_PeakDuelMatchWindow";
	self.skinName = "PeakDuelMatchWindow_skin";
	self.showBlackMask = true;
end

function Lua_PeakDuelMatchWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("PEAK_DUEL_MATCH", self, self.updateMatchInfo);
	self:addLuaEvent("PEAK_DUEL_BUY_TIMES", self, self.updateTimes);
	self:addLuaEvent("UPDATE_HERO_LINEUP_INFO", self, self.updateSelfLineup);

	self.selfAvatar = Lua_AvatarItem.new(self.selfObject);
	self.selfAvatar:setLocation(300, 60, 0);

	self.cbModify.selected = DataCenter.roleData:getOperationRecord("peak_duel_skip_lineup") == 1;
	self.cbModify:addBoxChange(self, self.onModifyChange);

	self.match_add:addClickFuntion(self, self.onBuyMatchTimes);
	self.btnLineup:addClickFuntion(self, self.onBtnLineupClick);
	self.btnMatch:addClickFuntion(self, self.onBtnMatchClick);
	self.btnFight:setEnable(false);
	self.btnFight:addClickFuntion(self, self.onBtnFightClick);
	self.btnHide:addClickFuntion(self, self.onBtnHideClick);

	self:updateShowInfo();
	Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDMatchInfo();
end

function Lua_PeakDuelMatchWindow:dispose()
	self:endTimer();
	DataCenter.preLoadData:removeBySign("Lua_PeakDuelLineupWindow", self, self.onSceneShow);
	if self.selfAvatar ~= nil then
		self.selfAvatar:dispose();
		self.selfAvatar = nil;
	end
	if self.rivalAvatar ~= nil then
		self.rivalAvatar:dispose();
		self.rivalAvatar = nil;
	end
	if self.myMatchPanel ~= nil then
		self.myMatchPanel:dispose();
		self.myMatchPanel = nil;
	end
	if self.rivalMatchPanel ~= nil then
		self.rivalMatchPanel:dispose();
		self.rivalMatchPanel = nil;
	end
	self:superCall("dispose");
end

function Lua_PeakDuelMatchWindow:onModifyChange(state)
	if state == true then
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOperate("peak_duel_skip_lineup", 1);
	else
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOperate("peak_duel_skip_lineup", 0);
	end
end

function Lua_PeakDuelMatchWindow:updateShowInfo()
	local roleData = DataCenter.roleData;
	local avatarId = roleData:getOwnDressUpId(Lua_DressUpDefine.MAINTYPE_HEAD);
	local frameId = roleData:getOwnDressUpId(Lua_DressUpDefine.MAINTYPE_FRAME);
	
	self.self_name.text = "["..roleData.server_flag.."]"..roleData.name;
	self.selfAvatar:setRoleAvatar(avatarId);
	self.selfAvatar:setRoleVip(roleData.vip);
	self.selfAvatar:setRoleFrame(frameId);
	
	local segmentLvl = DataCenter.peakDuelData.segmentLvl;
	local configData = DataCenter.peakDuelUtil:getSegmentInfoByid(segmentLvl);
	self.self_segment.text = configData.name;

	self.bSatisfySegment = configData.large_segment >= DataCenter.peakDuelUtil.show_group_segment;-- 是否满足段位
end

function Lua_PeakDuelMatchWindow:updateMatchInfo(match_info)
	if DataCenter.peakDuelData.match_result == 0 then
		self.noneObject:SetActive(true);
		self.rivalObject:SetActive(false);
		self.cbModify:setEnable(true);
		self.btnMatch:setEnable(true);
		self.btnFight:setEnable(false);

		self:endTimer();
		self.fightTime.text = "";
		self:updateRivalLineup(nil);
	else
		self.noneObject:SetActive(false);
		self.rivalObject:SetActive(true);
		self.cbModify:setEnable(false);
		self.btnMatch:setEnable(false);
		self.btnFight:setEnable(true);

		self.endTime = tonumber(match_info.fight_start_tick);
		self.leftSecond = self.endTime - DataCenter.roleData.serverTime;
		if self.leftSecond > 0 then
			self:onTimer();
			self:startTimer();
		else
			self:endTimer();
		end
		self:updateRivalLineup(match_info);
	end

	self:updateSelfLineup();
	self:updateTimes();
end

function Lua_PeakDuelMatchWindow:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_PeakDuelMatchWindow", 1, self, self.onTimer);
	end
end

function Lua_PeakDuelMatchWindow:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_PeakDuelMatchWindow:onTimer()
	self.leftSecond = self.endTime - DataCenter.roleData.serverTime;
	if self.leftSecond > 0 then
		self.fightTime.text = LanUtil.formateStr("{1}s后进入战斗", tostring(self.leftSecond));
	else
		self:endTimer();
		self.fightTime.text = "";
	end
end

function Lua_PeakDuelMatchWindow:updateRivalLineup(info)
	if info == nil or info.show_role == nil or tonumber(info.show_role.id) <= 0 then
		return;
	end

	self.rival_name.text = "["..info.show_role.server_flag.."]"..info.show_role.name;

	if self.rivalAvatar == nil then
		self.rivalAvatar = Lua_AvatarItem.new(self.rivalObject);
		self.rivalAvatar:setLocation(-300, 500, 0);
	end
	self.rivalAvatar:setRoleDressUp(info.show_role.dress_info);
	self.rivalAvatar:setRoleVip(info.show_role.vip);

	local configData = DataCenter.peakDuelUtil:getSegmentInfoByid(info.segment_lvl);
	self.rival_segment.text = configData.name;

	if self.rivalMatchPanel == nil then
		self.rivalMatchPanel = Lua_PeakDuelMatchPanel.new(self.rivalObject, 2);
		self.rivalMatchPanel:setLocation(0, 350, 0);
	end
	if self.bSatisfySegment == true then
		self.rivalMatchPanel:setDir(1);
	else
		self.rivalMatchPanel:setDir(2);
	end
	self.rivalMatchPanel:showTeam2(self.bSatisfySegment);
	self.rivalMatchPanel:setDataByProto(info.lineup);
end

function Lua_PeakDuelMatchWindow:updateSelfLineup()
	if self.myMatchPanel == nil then
		self.myMatchPanel = Lua_PeakDuelMatchPanel.new(self.selfObject, 0);
		self.myMatchPanel:setLocation(0, -110, 0);
	end
	self.myMatchPanel:setDir(1);
	self.myMatchPanel:showTeam2(self.bSatisfySegment);
	self.myMatchPanel:setDataByLineupType(Lua_HeroUtil.LINEUP_PEAKDUEL);
end

function Lua_PeakDuelMatchWindow:updateTimes()
	local left_buy_times = DataCenter.peakDuelData.left_buy_times;
	local left_match_times = DataCenter.peakDuelData.left_match_times;
	local match_times = DataCenter.peakDuelUtil.match_times;

	if left_match_times == 0 then
		tab = { "<color=#FF0000>", left_match_times, "</color>" };
	else
		tab = { "<color=#FFFFFF>", left_match_times, "</color>" };
	end
	self.match_add:setGray(left_buy_times == 0);
	self.match_add.mouseEnable = left_buy_times > 0;
	
	self.match_times.text = LanUtil.formateStr(202913, table.concat( tab, "" ), tostring(match_times));
	self.match_buy_times.text = LanUtil.formateStr(202914, tostring(left_buy_times));
end

function Lua_PeakDuelMatchWindow:onBuyMatchTimes(go)
	local vipVo = DataCenter.vipData.curVipLevelVo;
	local buy_time = vipVo.peak_duel_buy_times - DataCenter.peakDuelData.left_buy_times; -- 总次数-剩余次数=已购买次数
	local configData = DataCenter.peakDuelUtil:getMatchTimesConfig(buy_time + 1);
	self.matchTimesCost = configData.json_value;

	local tipsData = {
		des = LanUtil.formateStr(202915, self.matchTimesCost[1][2]),
		btnType = 1, owner = self, sureFun = self.onSureBuyMatch
	};
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_PeakDuelMatchWindow:onSureBuyMatch()
	local costId = DataCenter.packData:checkConsumeEnough(self.matchTimesCost);
	if costId == nil then
		Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDBuyTimes();
	else
		DataCenter.packUtil:openPathWindow(costId, false);
	end
end

function Lua_PeakDuelMatchWindow:onBtnLineupClick(go)
	local sceneId = DataCenter.heroLineupData:getLineUpSceneId(Lua_HeroUtil.LINEUP_PEAKDUEL);
	DataCenter.preLoadData:preShowScene("Lua_PeakDuelLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end

function Lua_PeakDuelMatchWindow:onSceneShow(param)
	local configData = DataCenter.peakDuelUtil:getSegmentInfoByid(DataCenter.peakDuelData.segmentLvl);
	local useTeamNum = (configData.large_segment > DataCenter.peakDuelUtil.show_group_segment) and 2 or 1;
	Lua_WindowUtil.openWin("Lua_PeakDuelLineupWindow", Lua_WinParam.ACTION_OPEN, useTeamNum);
end

function Lua_PeakDuelMatchWindow:onBtnMatchClick(go)
	local isSkip = DataCenter.roleData:getOperationRecord("peak_duel_skip_lineup");
	Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDMatch(isSkip);
end

function Lua_PeakDuelMatchWindow:onBtnFightClick(go)
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(Lua_FightDefine.TEMPLATE_ID_PEAKDUEL);
end

function Lua_PeakDuelMatchWindow:onBtnHideClick(go)
	self:hide();
end