--模型展示
Lua_PeakDuelModelItem = class("Lua_PeakDuelModelItem", Lua_DisplayObject);
function Lua_PeakDuelModelItem:ctor(p)
    self:superCall("ctor", p, "PeakDuelModelItem_skin");
end

function Lua_PeakDuelModelItem:buildShowItem()
    self:superCall("buildShowItem");
    self.like_btn:addClickFuntion(self, self.onLikeClick);
end

function Lua_PeakDuelModelItem:dispose()
	self.data = nil;
	self:superCall("dispose");
end

function Lua_PeakDuelModelItem:setRank(rank)
	self.titleIcon:setAltas("peak_duel_altas", "ui_grxx_ch_0"..rank);
	self.rank_txt.text = LanUtil.formateStr("赛区第{1}", convert_arab_to_chinese(rank));
end

function Lua_PeakDuelModelItem:setData(data)
	self.data = data;

	if data == nil then
		self.segmentIcon:setEnable(false);
		self.score_txt.text = "";
		self.name_txt.text = "虚位以待";
		self.faction_txt.text = "";
		self.heat_bg:setEnable(false);
		self.heat_txt.text = "";
		self.like_btn:setEnable(false);
	else
		local configData = DataCenter.peakDuelUtil:getSegmentInfoByid(data.segment_lvl);
		self.segmentIcon:setEnable(true);
		self.segmentIcon:setAltas("peak_duel_altas", configData.icon_path);
		self.score_txt.text = data.score;
		self.name_txt.text = data.show_role.name;
		if tonumber(data.show_role.league_id) > 0 then
			self.faction_txt.text = data.show_role.league_name;
		else
			self.faction_txt:setLangValue(20);
		end
		self.heat_bg:setEnable(true);
		self.heat_txt.text = LanUtil.formateStr("人气{1}", data.praise_num);
		self.like_btn:setEnable(true);

		if data.is_praised == 1 then
			self.like_btn:setAltas("common_altas_2", "ui_common_button_037_n");
			self.like_btn.mouseEnable = false;
		else
			self.like_btn:setAltas("common_altas_2", "ui_common_button_038_n");
			self.like_btn.mouseEnable = true;
		end
	end
end

function Lua_PeakDuelModelItem:onLikeClick(go)
	if self.data == nil then
		return;
	end
	if DataCenter.peakDuelData.left_praise_times <= 0 then
		OperateAlert.show("今日点赞次数已用完");
		return;
	end
    Lua_MsgUtil.callFunc("PEAK_DUEL_RANK_LIKE", self.data);
end