Lua_PeakDuelMySchedulePanel = class("Lua_PeakDuelMySchedulePanel", Lua_DisplayObject)
function Lua_PeakDuelMySchedulePanel:ctor(p)
	self:superCall("ctor", p, "PeakDuelMySchedulePanel_skin")
end

function Lua_PeakDuelMySchedulePanel:buildShowItem()
	self:superCall("buildShowItem")

	self:addLuaEvent("PEAK_DUEL_INFO", self, self.peakDuelInfo)
	self:addLuaEvent("PEAK_DUEL_HOOK_INFO", self, self.updateHookInfo)
	self:addLuaEvent("PEAK_DUEL_RANK_REWARD", self, self.updateRewardInfo)
	self:addLuaEvent("PEAK_DUEL_RANK_UPDATE", self, self.showModelItem)
	self:addLuaEvent("PEAK_DUEL_BUY_TIMES", self, self.updateTimes)
	self:addLuaEvent("PEAK_DUEL_RANK_LIKE", self, self.onLike)

	self.expBar:createSecondBar("peak_duel_altas", "xui_dfs_Progress_1_f2")

	self.checkHelp:addClickFuntion(self, self.onCheckHelp) --功能描述
	self.checkStore:addClickFuntion(self, self.onCheckStore) -- 段位商店
	self.checkStandings:addClickFuntion(self, self.onCheckStandings) -- 个人战绩
	self.checkReward:addClickFuntion(self, self.onCheckReward) -- 赛季奖励
	self.checkKing:addClickFuntion(self, self.onCheckKing) -- 王者之证

	self.hookIcon_1:addClickFuntion(self, self.onReceiveHookReward) -- 领取挂机奖励
	self.btnReceive:addClickFuntion(self, self.onReceiveReward) -- 领取奖励
	self.rewardDetails:addClickFuntion(self, self.onRewardDetails) -- 奖励详情
	self.checkRecord:addClickFuntion(self,self.onCheckRecord) -- 战报
	self.timesAdd:addClickFuntion(self, self.onBuyMatchTimes) -- 购买匹配次数

	self.changeLineup:addClickFuntion(self, self.onLineup) -- 阵容调整
	self.btnMatch:addClickFuntion(self, self.onBtnMatchClick) -- 开始匹配

	self.btnLineup:addClickFuntion(self, self.onLineup) -- 阵容调整
	self.btnRecord:addClickFuntion(self, self.onCheckRecord) -- 战报

	Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDInfo()
end

function Lua_PeakDuelMySchedulePanel:dispose()
	self:stopTimer()
	DataCenter.preLoadData:removeBySign("Lua_PeakDuelLineupWindow", self, self.onSceneShow)
	if self.rewardList then
		self.rewardList:dispose()
		self.rewardList = nil
	end
	if self.upgradeArr then
		self.upgradeArr:dispose()
		self.upgradeArr:clear()
		self.upgradeArr = nil
	end
	if self.modelArr then
		self.modelArr:dispose()
		self.modelArr:clear()
		self.modelArr = nil
	end
	self.upResultDic = nil
	self:superCall("dispose")
end

function Lua_PeakDuelMySchedulePanel:peakDuelInfo(msg)
	if msg == nil then
		return
	end

	local star_time = Lua_TimeTransform.transSeconds25(msg.start_tick, false)
	local end_time = Lua_TimeTransform.transSeconds25(msg.end_tick, false)
	self.timeText.text = LanUtil.formateStr(202900, tostring(msg.times), msg.region_name, star_time, end_time)

	--是否是休赛期 1：是 0：不是
	if msg.is_off_season == 0 then
		self.onObject:SetActive(true)
		self.offObject:SetActive(false)

		self.endTime = tonumber(msg.match_end_tick)
		self.timeLangId = 202901

		self:updateMatchStartInfo(msg)
		self:updateHookInfo(msg)
		self:updateTimes()
		self:updateRewardInfo(msg)
	else
		self.onObject:SetActive(false)
		self.offObject:SetActive(true)

		self.endTime = tonumber(msg.end_tick)
		self.timeLangId = 202909

		self.bCheckHookTime = false
		self:updateMatchEndInfo(msg)
		self:showModelItem()
	end

	self.leftTime = self.endTime - DataCenter.roleData.serverTime
	self.leftTimeText.text = LanUtil.formateStr(self.timeLangId, Lua_TimeTransform.transSeconds18(self.leftTime, true, true, true, true))
	if self.leftTime > 0 then
		self.bCheckEndTime = true
		self:startTimer()
	else
		self.bCheckEndTime = false
	end

	self.matchCoolTime = DataCenter.peakDuelData.matchCoolTime
	if self.matchCoolTime > 0 then
		self.bCheckCoolTime = true
		self.btnMatch:setBtnEnable(false)
		self.promptText.text = LanUtil.formateStr(202932, Lua_TimeTransform.transSeconds6(self.matchCoolTime))
		self:startTimer()
	else
		self.bCheckCoolTime = false
	end
end

function Lua_PeakDuelMySchedulePanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true
		self:addTimer("Lua_PeakDuelMySchedulePanel", 1, self, self.onTimer)
	end
end

function Lua_PeakDuelMySchedulePanel:stopTimer()
	if self.bTimer == true then
		self.bTimer = false
		self:removeTimer(self, self.onTimer)
	end
end

function Lua_PeakDuelMySchedulePanel:onTimer()
	if self.bCheckHookTime ~= true and self.bCheckEndTime ~= true and self.bCheckCoolTime ~= true then
		self:stopTimer()
		return
	end

	if self.bCheckHookTime == true then
		self.intervalNum = self.intervalNum + 1
		if self.intervalNum > 59 then -- 1分钟更新挂机收益
			Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDHookTime()
			self.intervalNum = 0
		end

		self.hook_time = self.hook_time + 1
		self.hookText_1.text = Lua_TimeTransform.transSeconds6(self.hook_time)
	end

	if self.bCheckEndTime == true then
		self.leftTime = self.endTime - DataCenter.roleData.serverTime
		if self.leftTime > 0 then
			self.leftTimeText.text = LanUtil.formateStr(self.timeLangId, Lua_TimeTransform.transSeconds18(self.leftTime, true, true, true, true))
		else
			self.bCheckEndTime = false
			self.leftTimeText.text = nil
			Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDInfo()
		end
	end

	if self.bCheckCoolTime == true then
		self.matchCoolTime = self.matchCoolTime - 1
		if self.matchCoolTime > 0 then
			self.promptText.text = LanUtil.formateStr(202932, Lua_TimeTransform.transSeconds6(self.matchCoolTime))
		else
			self.bCheckCoolTime = false
			self.btnMatch:setBtnEnable(true)
			self.promptText:setLangValue(self.promptLangId)
		end
	end
end

---------- 比赛期
function Lua_PeakDuelMySchedulePanel:updateMatchStartInfo(msg)
	local configData = DataCenter.peakDuelUtil:getSegmentInfoByid(msg.segment_lvl)
	self.segmentName.text = configData.name
	self.segmentIcon:setAltas("peak_duel_altas", configData.icon)
	self.winRateText.text = LanUtil.formateStr(202902, tostring(msg.normal_win_rate * 100))
	self.winText.text = LanUtil.formateStr(202903, tostring(msg.max_streak_win))
	if msg.rank == 0 then
		self.myRankText:setLangValue(202907)
	else
		self.myRankText.text = LanUtil.formateStr(202908, tostring(msg.rank))
	end

	if msg.is_upgrade == 1 then -- 是否在进行升段赛 1是 0否
		self.barObject:SetActive(false)
		self.upgradeLabel:setEnable(true)

		local list = configData.upgrade_segment_cond
		self.upgradeLabel.text = LanUtil.formateStr(202910, tostring(list[1]), tostring(list[2]))
		
		self.upResultDic = {} -- key:升段赛的第几场 value:战斗结果 1胜利 0失败
		if msg.upgrade_result ~= nil then
			local obj
			for i = 1, #msg.upgrade_result do
				obj = msg.upgrade_result[i]
				self.upResultDic[obj.key] = obj.value
			end
		end

		self:showUpgrade(list[1])
	else
		self.barObject:SetActive(true)
		self.upgradeLabel:setEnable(false)

		self.expBar:setSecondMaxValue(configData.segment_lvl_cond)
	    self.expBar:setSecondValue(msg.segment_lvl_exp)

		self.expBar:setMaxValue(configData.segment_lvl_cond)
		self.expBar:setValue(msg.cache_exp)

		self.expText.text = msg.cache_exp.."/"..configData.segment_lvl_cond
	end

	if configData.team_num <= 1 then
		self.promptLangId = 202911
	else
		self.promptLangId = 202912
	end
	self.promptText:setLangValue(self.promptLangId)

	self.score_limit = configData.score_limit -- 收益上限
	self.sec_score = configData.each_sec_score[2] -- 每分钟产出的积分
end

function Lua_PeakDuelMySchedulePanel:showUpgrade(num)
    if self.upgradeArr == nil then
        self.upgradeArr = Array()
    end

    local len = num - self.upgradeArr:getSize()
	while (len > 0) do
		item = Lua_PeakDuelUpgradeItem.new(self.upgradeObj)
		self.upgradeArr:add(item)
		len = len - 1
	end

	while (len < 0) do
		item = self.upgradeArr:remove(1)
		item:dispose()
		len = len + 1
	end

	len = self.upgradeArr:getSize()
	local space = 50
	local w
	local posX
	for i = 1, len do
		item = self.upgradeArr[i]
		item:setData(self.upResultDic[i])

		w = -(space * len) / 2 + space / 2
		posX = ((i - 1) % len) * space + w
		item:setLocation(posX, -135, 0)
	end
end

function Lua_PeakDuelMySchedulePanel:updateHookInfo(msg)
	self.intervalNum = 0
	self.hook_time = tonumber(msg.offline_duration) -- 开始挂机时长
	self.hookText_1.text = Lua_TimeTransform.transSeconds6(self.hook_time)
	self.hookText_2.text = LanUtil.formateStr(202904, tostring(self.sec_score))
	self.hookText_3.text = msg.offline_score_profit.."/"..self.score_limit
	if msg.offline_score_profit >= self.score_limit then
		self.bCheckHookTime = false
	else
		self.bCheckHookTime = true
		self:startTimer()
	end
end

function Lua_PeakDuelMySchedulePanel:updateTimes()
	local left_buy_times = DataCenter.peakDuelData.left_buy_times
	local left_match_times = DataCenter.peakDuelData.left_match_times
	local match_times = DataCenter.peakDuelUtil.match_times

	self.timesAdd:setGray(left_buy_times == 0)
	self.timesAdd.mouseEnable = left_buy_times > 0
	
	self.timesText.text = LanUtil.formateStr(202913, tostring(left_match_times), tostring(match_times))
	self.timesBuyText.text = LanUtil.formateStr(202914, tostring(left_buy_times))
end

function Lua_PeakDuelMySchedulePanel:updateRewardInfo(msg)
	local configData = DataCenter.peakDuelUtil:getSegmentInfoByid(msg.segment_reward_id)

	self.nextLvText.text = LanUtil.formateStr(202905, configData.name)
	if self.rewardList == nil then
		self.rewardList = Lua_ItemIconList.new(self.onObject)
		self.rewardList:setRectAnchor(7)
		self.rewardList:setLocation(-290, 303.5, 0)
		self.rewardList.pivot = 1
		self.rewardList.scaleVal = 0.75
		self.rewardList.canClick = true
	end
	self.rewardList:setArrayData(configData.segment_lvl_reward)

	self.rewardText.text = LanUtil.formateStr(202906, configData.name)
	self.btnReceive:setBtnEnable(msg.segment_reward_state == 1)
end

---------- 休赛期
function Lua_PeakDuelMySchedulePanel:updateMatchEndInfo(msg)
	if msg.rank == 0 then
		self.maxRankText:setLangValue(202916)
	else
		self.maxRankText.text = LanUtil.formateStr(202917, tostring(msg.rank))
	end
	
	local configData = DataCenter.peakDuelUtil:getSegmentInfoByid(msg.segment_lvl)
	self.curText.text = configData.name
	self.curIcon:setAltas("peak_duel_altas", configData.icon)

	configData = DataCenter.peakDuelUtil:getSegmentInfoByid(configData.reset_segment_lvl_id)
	self.nextIcon:setAltas("peak_duel_altas", configData.icon)
	self.nextText.text = configData.name
end

function Lua_PeakDuelMySchedulePanel:showModelItem()
	if self.modelArr == nil then
		self.modelArr = Array()
	end

	local rankDic = DataCenter.peakDuelData.rankDic
	local pos = {{0, 227}, {-213, -87}, {213, -87}}
	local item
	for i = 1, 3 do
		item = self.modelArr[i]
		if item == nil then
			item = Lua_PeakDuelModelItem.new(self.offObject)
			self.modelArr:add(item)
		end
		item:setLocation(pos[i][1], pos[i][2], 0)
		item:setRank(i)
		if rankDic == nil then
			item:setData(nil)
		else
			item:setData(rankDic[i])
		end
	end
end

function Lua_PeakDuelMySchedulePanel:onLike(data)
	Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDLike(data.role_id, 0, DataCenter.peakDuelData.times, data.score)
end

function Lua_PeakDuelMySchedulePanel:onCheckHelp(go)
	local tipsData = { des = 202937, posX = 150, posY = -280 }
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData)
end

function Lua_PeakDuelMySchedulePanel:onCheckStore(go)
	DataCenter.funcPathUtil:gotoFunction(1095)
end

function Lua_PeakDuelMySchedulePanel:onCheckStandings(go)
	local param = { regionId = DataCenter.peakDuelData.region_id, roleId = DataCenter.roleData.roleId, serverFlag = DataCenter.roleData.server_flag }
	Lua_WindowUtil.openWin("Lua_PeakDuelStandingsWindow", Lua_WinParam.ACTION_OPEN, param)
end

function Lua_PeakDuelMySchedulePanel:onCheckReward(go)
	Lua_WindowUtil.openWin("Lua_PeakDuelRewardWindow", Lua_WinParam.ACTION_OPEN, 2)
end

function Lua_PeakDuelMySchedulePanel:onCheckKing(go)
	DataCenter.funcPathUtil:gotoFunction(1023)
end

function Lua_PeakDuelMySchedulePanel:onReceiveHookReward(go)
	Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDHook()
end

function Lua_PeakDuelMySchedulePanel:onReceiveReward(go)
	Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDDanReward()
end

function Lua_PeakDuelMySchedulePanel:onRewardDetails(go)
	Lua_WindowUtil.openWin("Lua_PeakDuelRewardWindow", Lua_WinParam.ACTION_OPEN, 1)
end

function Lua_PeakDuelMySchedulePanel:onBuyMatchTimes(go)
	local vipVo = DataCenter.vipData.curVipLevelVo
	local buy_time = vipVo.peak_duel_buy_times - DataCenter.peakDuelData.left_buy_times -- 总次数-剩余次数=已购买次数
	local configData = DataCenter.peakDuelUtil:getMatchTimesConfig(buy_time + 1)
	self.matchTimesCost = configData.json_value

	local tipsData = {
		des = LanUtil.formateStr(202915, self.matchTimesCost[1][2]), btnType = 1, owner = self, sureFun = self.onSureBuyMatch
	}
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData)
end

function Lua_PeakDuelMySchedulePanel:onSureBuyMatch()
	local costId = DataCenter.packData:checkConsumeEnough(self.matchTimesCost)
	if costId == nil then
		Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDBuyTimes()
	else
		DataCenter.packUtil:openPathWindow(costId, false)
	end
end

function Lua_PeakDuelMySchedulePanel:onLineup(go)
	local sceneId = DataCenter.heroLineupData:getLineUpSceneId(Lua_HeroUtil.LINEUP_PEAKDUEL)
	DataCenter.preLoadData:preShowScene("Lua_PeakDuelLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0)
end

function Lua_PeakDuelMySchedulePanel:onSceneShow(param)
	local configData = DataCenter.peakDuelUtil:getSegmentInfoByid(DataCenter.peakDuelData.segmentLvl)
	local lineupNum = (configData.large_segment > DataCenter.peakDuelUtil.show_group_segment) and 2 or 1
	Lua_WindowUtil.openWin("Lua_PeakDuelLineupWindow", Lua_WinParam.ACTION_OPEN, lineupNum)
end

function Lua_PeakDuelMySchedulePanel:onCheckRecord()
	Lua_WindowUtil.openWin("Lua_PeakDuelFightRecordWindow", Lua_WinParam.ACTION_OPEN)
end

function Lua_PeakDuelMySchedulePanel:onBtnMatchClick(go)
	local recordId = DataCenter.fightData:getRecordIdByTemplateId(Lua_FightDefine.TEMPLATE_ID_PEAKDUEL)
	if recordId > 0 then
		DataCenter.fightData:showFightToStageByRid(recordId)
		return
	end
	Lua_WindowUtil.openWin("Lua_PeakDuelMatchWindow", Lua_WinParam.ACTION_OPEN)
end




















--晋级赛展示
Lua_PeakDuelUpgradeItem = class("Lua_PeakDuelUpgradeItem", Lua_DisplayObject)
function Lua_PeakDuelUpgradeItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_PeakDuelUpgradeItem:buildShowItem()
	self:superCall("buildShowItem")
	
	self.icon = UICreate.createUIAtlasImage(self.content, "common_altas_3", "ui_djc_toggle_001_b", 0, 0, 0, 0)
end

function Lua_PeakDuelUpgradeItem:setData(data)
	if data == 1 then --1胜利 0失败
		self.icon:setAltas("common_altas_3", "ui_djc_toggle_001_f")
	else
		self.icon:setAltas("common_altas_3", "ui_djc_toggle_001_b")
	end
end

function Lua_PeakDuelUpgradeItem:dispose()
	self:superCall("dispose")
end